
From: William Lee Irwin III <wli@holomorphy.com>

Fix up sparc32 properly.
DESC
sun4d fork_idle() fix
EDESC
From: William Lee Irwin III <wli@holomorphy.com>

Minor gaffe in sun4d_smp.c for fork_idle(), where the arguments to
init_idle() weren't updated.  This patch updates them to fix it.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/sparc/kernel/sun4d_smp.c |    2 +-
 25-akpm/arch/sparc/kernel/sun4m_smp.c |   11 +----------
 2 files changed, 2 insertions(+), 11 deletions(-)

diff -puN arch/sparc/kernel/sun4d_smp.c~sched-sparc32-fix arch/sparc/kernel/sun4d_smp.c
--- 25/arch/sparc/kernel/sun4d_smp.c~sched-sparc32-fix	Mon Aug 16 16:04:16 2004
+++ 25-akpm/arch/sparc/kernel/sun4d_smp.c	Mon Aug 16 16:04:18 2004
@@ -201,7 +201,7 @@ void __init smp4d_boot_cpus(void)
 			int no;
 
 			/* Cook up an idler for this guy. */
-			p = fork_idle(p, cpu);
+			p = fork_idle(i);
 			cpucount++;
 			current_set[i] = p->thread_info;
 			for (no = 0; !cpu_find_by_instance(no, NULL, &mid)
diff -puN arch/sparc/kernel/sun4m_smp.c~sched-sparc32-fix arch/sparc/kernel/sun4m_smp.c
--- 25/arch/sparc/kernel/sun4m_smp.c~sched-sparc32-fix	Mon Aug 16 16:04:16 2004
+++ 25-akpm/arch/sparc/kernel/sun4m_smp.c	Mon Aug 16 16:04:16 2004
@@ -173,18 +173,9 @@ void __init smp4m_boot_cpus(void)
 			int timeout;
 
 			/* Cook up an idler for this guy. */
-			kernel_thread(start_secondary, NULL, CLONE_IDLETASK);
-
+			p = fork_idle(i);
 			cpucount++;
-
-			p = prev_task(&init_task);
-
-			init_idle(p, i);
-
 			current_set[i] = p->thread_info;
-
-			unhash_process(p);
-
 			/* See trampoline.S for details... */
 			entry += ((i-1) * 3);
 
_
